<?php
/**
 * InlineResponse20040ContentItemsAllOf1
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20040ContentItemsAllOf1 Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20040ContentItemsAllOf1 implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_40_contentItems_allOf_1';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'history' => '\SLIS\Adapter\Tanss\Model\InlineResponse20040ContentItemsAllOfHistoryInner[]',
        'dayClosing' => '\SLIS\Adapter\Tanss\Model\InlineResponse20110Content',
        'editMode' => 'string',
        'changesRequested' => '\SLIS\Adapter\Tanss\Model\InlineResponse20040ContentItemsAllOfChangesRequestedInner[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'history' => null,
        'dayClosing' => null,
        'editMode' => null,
        'changesRequested' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'history' => 'history',
        'dayClosing' => 'dayClosing',
        'editMode' => 'editMode',
        'changesRequested' => 'changesRequested'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'history' => 'setHistory',
        'dayClosing' => 'setDayClosing',
        'editMode' => 'setEditMode',
        'changesRequested' => 'setChangesRequested'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'history' => 'getHistory',
        'dayClosing' => 'getDayClosing',
        'editMode' => 'getEditMode',
        'changesRequested' => 'getChangesRequested'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const EDIT_MODE_NONE = 'NONE';
    public const EDIT_MODE_MAY_REQUEST = 'MAY_REQUEST';
    public const EDIT_MODE_DIRECT_ACCESS = 'DIRECT_ACCESS';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getEditModeAllowableValues()
    {
        return [
            self::EDIT_MODE_NONE,
            self::EDIT_MODE_MAY_REQUEST,
            self::EDIT_MODE_DIRECT_ACCESS,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['history'] = $data['history'] ?? null;
        $this->container['dayClosing'] = $data['dayClosing'] ?? null;
        $this->container['editMode'] = $data['editMode'] ?? null;
        $this->container['changesRequested'] = $data['changesRequested'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getEditModeAllowableValues();
        if (!is_null($this->container['editMode']) && !in_array($this->container['editMode'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'editMode', must be one of '%s'",
                $this->container['editMode'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets history
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20040ContentItemsAllOfHistoryInner[]|null
     */
    public function getHistory()
    {
        return $this->container['history'];
    }

    /**
     * Sets history
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20040ContentItemsAllOfHistoryInner[]|null $history history of all timestamp changes of this employee / day
     *
     * @return self
     */
    public function setHistory($history)
    {
        $this->container['history'] = $history;

        return $this;
    }

    /**
     * Gets dayClosing
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20110Content|null
     */
    public function getDayClosing()
    {
        return $this->container['dayClosing'];
    }

    /**
     * Sets dayClosing
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20110Content|null $dayClosing dayClosing
     *
     * @return self
     */
    public function setDayClosing($dayClosing)
    {
        $this->container['dayClosing'] = $dayClosing;

        return $this;
    }

    /**
     * Gets editMode
     *
     * @return string|null
     */
    public function getEditMode()
    {
        return $this->container['editMode'];
    }

    /**
     * Sets editMode
     *
     * @param string|null $editMode describes how a timestamp was (or may be) edited * NONE = may not be edited * MAY_REQUEST = user may only request changes * DIRECT_ACCESS = timestamps may be modified directyl
     *
     * @return self
     */
    public function setEditMode($editMode)
    {
        $allowedValues = $this->getEditModeAllowableValues();
        if (!is_null($editMode) && !in_array($editMode, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'editMode', must be one of '%s'",
                    $editMode,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['editMode'] = $editMode;

        return $this;
    }

    /**
     * Gets changesRequested
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20040ContentItemsAllOfChangesRequestedInner[]|null
     */
    public function getChangesRequested()
    {
        return $this->container['changesRequested'];
    }

    /**
     * Sets changesRequested
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20040ContentItemsAllOfChangesRequestedInner[]|null $changesRequested if any change requests are present for this user / day, they are given here
     *
     * @return self
     */
    public function setChangesRequested($changesRequested)
    {
        $this->container['changesRequested'] = $changesRequested;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


